/*#######################################################################################
AVR Small Webserver 
Copyright (C) 2004 Ulrich Radig
Copyright (C) 2005 Joachim Brke

In dieser Datei werden Seiten an den Client geliefert. 
Die Platzhalter werden gegen Daten getauscht.

#######################################################################################*/

#include "main.h"
#include "tcp.h" 
#include "mmc.h"
#include "OWIPolled.h"
#include "OWIcrc.h"
#include "dump.h"

//Globale Variablen

unsigned int sitecounter=0;
unsigned int result16;
unsigned long Seq_counter;
unsigned long Ack_counter;


struct TCP_Socket tcpsockets[Max_TCP_Sockets]; //Feld mit Max_TCP_Sockets Sockets
struct TCP_Socket *tcp_socket;                 //Pointer auf einen TCP_Socket

PGM_P pointerold;

PROGMEM char selected[] = {"selected"};
PROGMEM char checked[]  = {"checked"};

//############################################################################
// Ausgabe der Variablen xx als zwei- bis dreistellige Dezimalzahl in den 
// Buffer schreiben um die Variable auf einer Webseite anzeigen zu knnen
//
void dec_out (char *buffer,char xx)
//############################################################################
{
	if (xx>99) { buffer[result16++]=(unsigned char)(xx/100)+'0'; xx=xx%100;}
	buffer[result16++] = (unsigned char)(xx/10) + '0';
	buffer[result16++] = (unsigned char)(xx%10) + '0';
}

//############################################################################
// Ausgabe der Variablen xx als zweistellige Hexadezimalzahl in den Buffer
// schreiben um die Variable auf einer Webseite anzeigen zu knnen
//
void hex_out (char *buffer,char xx)
//############################################################################
{
	unsigned char x;
	x = xx >> 4;
	buffer[result16++] = x>9 ? x+'A'-10 : x+'0';
	x = xx & 0x0f;
	buffer[result16++] = x>9 ? x+'A'-10 : x+'0';
}

//############################################################################
// Ausgabe der Seriennummer eines Dallas-Bausteins mit dem Index nr in Form
// einer achtstellige Hexadezimalzahl auf eine Webseite.
// Die Ausgabe erfolgt in den Buffer. 
//
void dallas_out (char *buffer,int nr)
//############################################################################
{
	unsigned char i = 7, 			// Die Adresse besteht aus sieben Byte
	crc = 0, 						// Startwert fr crc-Berechnung
	Datum;
	if (DALLAS[nr][0]==0x7f) 		// Wenn Feld nicht belegt ist
		for (i=0;i<16;i++) buffer[result16++]='-'; // -------- ausgeben
	else { 
		nr <<= 4;					// Feld ist 16 Byte gro
		do {
			Datum = eeprom_read_byte((char *)nr++);	// Datum aus dem EEPROM holen,
			crc = OWI_ComputeCRC8(Datum, crc);			//  in die CRC-Berechnung einbeziehen
			hex_out (buffer,Datum);					//  und als Hexzahl ausgeben
		} while (--i);
		hex_out (buffer,crc);		// crc-Summe anhngen
	}
}	

//############################################################################
// Ausgabe eines Strings aus dem Flashspeicher in den Buffer
//
void string_out (char *buffer, PGM_P Z)
//############################################################################
{
	while (buffer[result16] = pgm_read_byte(Z++)) result16++;
}

//############################################################################
//
void tcp_store (char *buffer)
//############################################################################
{
	unsigned int result16;	//Variablen Fr die Routine
	struct TCP_Header *tcp;	//Pointer auf TCP_Header
	tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];
	
	//Store seq number to Seq_counter
	Seq_counter = (tcp->TCP_Seqnum[0] << 8)+tcp->TCP_Seqnum[1];
	Seq_counter = Seq_counter << 16;
	Seq_counter = Seq_counter +(unsigned int) ((tcp->TCP_Seqnum[2] << 8) + tcp->TCP_Seqnum[3]);

    //Store ack number to ACK_counter
	Ack_counter = (tcp->TCP_Acknum[0] << 8)+tcp->TCP_Acknum[1];
	Ack_counter = Ack_counter << 16;
	Ack_counter = Ack_counter +(unsigned int) ((tcp->TCP_Acknum[2] << 8) + tcp->TCP_Acknum[3]);

	//Calculate next seq number
	if ((tcp->TCP_HdrFlags[1] & FIN_FLAG) == 0) {
		result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1];
		result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2)	- ((buffer[TCP_HDRFLAGS] & 0xF0) >>2);
		if ((buffer[TCP_HDRFLAGS+1]&SYN_FLAG) > 0	&& result16 == 0)	result16 = 1;
		Seq_counter =Seq_counter + result16;
	}
	return;
}

//############################################################################
//
unsigned char tcp_add_data (PGM_P pointer,char *buffer,int *bufferlen)
//############################################################################
{
	unsigned char Data = 1, i, j, Buffer_Full = 0;
	
	// Startpunkt der Daten im Tcp buffer errechnen 
	// IP Headerlnge + TCP Headerlnge + Ethernetframe
	result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	for(;;) {
		
		if (pgm_read_byte(pointer) =='%') {			// '%' bedeutet das eventuell ein <TAG> folgt
			
			// Ausgabe verschiedener Variablen mit der Kennung %VA...
			
			if (strncmp_P("VA",(pointer+1),2) == 0){	// Wird %VA gefunden, zugehrige Variable einfgen
				pointer++;  pointer++;  pointer++;		// pointer ber "%VA" hinwegsetzen
				
				if (pgm_read_byte(pointer) =='1') { 	// %VA1 = Variable 1; 5 stellige Dezimalzahl
					unsigned int tmp=sitecounter++;
					char counter[5]; 
					for(i=0; i<5; i++) {counter[i] = (unsigned char)(tmp%10)+'0'; tmp/=10;}          
					for(i=0; i<5; i++) buffer[result16++]=counter[4-i];
				}
				
				if (pgm_read_byte(pointer) =='2')	{	// %VA2 = Variable 2; binre- oder Ziffernausgabe
					i = pgm_read_byte(pointer+1);		// Folgezeichen einlesen
					if ((i=='-') | (i=='+')) {		// Bei folgendem "+" oder "-" bei Bedarf
						if ((VA2!=0)^(i=='-')) string_out(buffer,checked);	// 'checked' ausgeben
						pointer++; 	}			 		// "-,+" berlesen
					else dec_out(buffer,VA2);			// Wenn kein "+" oder "-" folgt, Dezimalwert ausgeben
				}
				
				if (pgm_read_byte(pointer) =='3')	{	// %VA3 = Variable 3; mehrere Zustnde binr ausgeben
					i = pgm_read_byte(++pointer)-'0';	// Ziffer einlesen, binr darstellen 
					if (VA3==i) string_out(buffer,checked);	//  und bei Gleichheit 'checked' ausgeben
				}
				
				if (pgm_read_byte(pointer) =='4')	{	// %VA4 = Variable 4; Binrausgabe; Bit 4 von BUSES
					i = pgm_read_byte(++pointer);		// Folgezeichen einlesen ("-" oder "+")
					if (((DALLAS[0][0]&OWI_PIN_4)>0)^(i=='-')) string_out(buffer,checked);	// 'checked' ausgeben
				}
				
				if (pgm_read_byte(pointer) =='5')	{	// %VA5 = Variable 5; Binrausgabe; Bit 5 von BUSES
					i = pgm_read_byte(++pointer);		// Folgezeichen einlesen ("-" oder "+")
					if (((DALLAS[0][0]&OWI_PIN_5)>0)^(i=='-')) string_out(buffer,checked);	// 'checked' ausgeben
				}
				
				if (pgm_read_byte(pointer) =='6')	{	// %VA6 = Variable 6; Binrausgabe; Bit 6 von BUSES
					i = pgm_read_byte(++pointer);		// Folgezeichen einlesen ("-" oder "+")
					if (((DALLAS[0][0]&OWI_PIN_6)>0)^(i=='-')) string_out(buffer,checked);	// 'checked' ausgeben
				}
				
				if (pgm_read_byte(pointer) =='R')	{	// %VAR = Variable R; mehrere Zustnde binr oder Ziffernausgabe
					i = pgm_read_byte(++pointer);		// Folgezeichen einlesen
					if (i=='*') dec_out(buffer,VAR);	// bei "*" Dezimalwert von VAR ausgeben
					else {	// sonst bei bereinstimmung von Variable und Folgeziffer 'selected' ausgeben
						i -= i>'9' ? 'A'-10 : '0';		// Zeichen als Index betrachten
						if (VAR==i) string_out(buffer,selected);	// 'selected' ausgeben
					}
				}
				
				if (pgm_read_byte(pointer) =='O')		// Index als ASCII ausgeben
					buffer[result16++] = Index>9 ? Index+'A'-10 : Index+'0';
				
				// verschiedene Dezimalausgaben
				
				if (pgm_read_byte(pointer) =='h')	dec_out(buffer,hh);		// Stunden einfgen
				if (pgm_read_byte(pointer) =='m')	dec_out(buffer,mm);		// Minuten einfgen
				if (pgm_read_byte(pointer) =='s')	dec_out(buffer,ss);		// Sekunden einfgen
				if (pgm_read_byte(pointer) =='L')	dec_out(buffer,Index);		// Index dezimal ausgeben
				if (pgm_read_byte(pointer) =='i')	dec_out(buffer,VAi);		// IP-Adresse, 1.Byte
				if (pgm_read_byte(pointer) =='j')	dec_out(buffer,VAj);		// IP-Adresse, 2.Byte
				if (pgm_read_byte(pointer) =='k')	dec_out(buffer,VAk);		// IP-Adresse, 3.Byte
				if (pgm_read_byte(pointer) =='l')	dec_out(buffer,VAl);		// IP-Adresse, 4.Byte
				
				// verschiedene komplexe Ausgaben
				
				if (pgm_read_byte(pointer) =='M')	{	// MAC-Adresse komplett ausgeben
					for(i=0; i<=5; i++) {				// MAC-Adresse besteht aus sechs Zahlen
						hex_out (buffer,mymac[i]);		// Hexadezimalzahl ausgeben
						if (i<5) buffer[result16++]=':';	// Doppelpunkt zwischen den Zahlen ausgeben
				}	}
				
				if (pgm_read_byte(pointer) =='I')	{	// IP-Adresse komplett ausgeben
					for(i=0; i<=3; i++) {				// IP-Adresse besteht aus vier Zahlen
						dec_out (buffer,MYIP[i]);		// Dezimalzahl ausgeben
						if (i<3) buffer[result16++]='.';	// Punkt zwischen den Zahlen ausgeben
				}	}
				
				if (pgm_read_byte(pointer) =='D')	{	// Dallasseriennummer komplett ausgeben
					i = pgm_read_byte(++pointer);		// Ziffer nach i laden
					if (i=='*') i=Index;				// '*' = Variable nutzen
					else i -= i>'9' ? 'A'-10 : '0';	// sonst Zeichen als Index betrachten
					dallas_out (buffer,i);				// one-wire-bus-Adresse ausgeben
				}
				
				if (pgm_read_byte(pointer) =='d')	{	// Temperatur komplett ausgeben
					i = pgm_read_byte(++pointer);		// Ziffer nach i laden
					if (i=='*') i=Index;				// '*' = Variable nutzen
					else i -= i>'9' ? 'A'-10 : '0';	// sonst Zeichen als Index betrachten
					if (DALLAS[i][1]!=0xff) {			// es handelt sich um ein Thermometer
						if (DALLAS[i][1]==0x7f) for (j=0;j<10;j++) buffer[result16++]='-';
						else {							//Temperatur ausgeben
							if (DALLAS[i][0]>127) buffer[result16++]='-';	// wenn Temperatur negativ, "-" ausgeben
							else if (DALLAS[i][0]<100) buffer[result16++]=' ';	// Feldausgleich
							dec_out (buffer,(DALLAS[i][0]&0x7f));	// Betrag der Temperatur ausgeben
							buffer[result16++]=',';				// Dezimalkomma
							dec_out (buffer,(DALLAS[i][1]&0x7f));	// Nachkommateil ausgeben
							buffer[result16++]='';				// Grad
							buffer[result16++]='C';				// Celsius
							buffer[result16++]=' ';				// Leerstelle
							buffer[result16++]=DALLAS[i][1]&0x80?'#':'-';// test auf external power supply
						}	
					}	
					else for (j=0;j<10;j++) buffer[result16++]=' '; // alle Ausgaben haben die gleiche Lnge
				}
				
				if (pgm_read_byte(pointer) =='N')	{					// Bausteinname komplett ausgeben
					i = pgm_read_byte(++pointer);						// Folgezeichen nach i laden
					for (j=8;j<16;j++) {								// 8 Byte aus demm EEPROM bearbeiten
						Data= eeprom_read_byte((char*)(Index<<4)+j);	// Zeichen aus dem EEPROM lesen
						if (Data==0xff) {}								// unbesetzt
						else if (Data>=' ') buffer[result16++]=Data;	// ASCII-Zeichen ausgeben
						else if (i=='/') {							// Token verkrzt ausgeben
							buffer[result16++]='*';					// '*' ausgeben
							Data += Data>9 ? 'A'-10 : '0';				// Tokennummer auf Basis 36 umrechnen
							buffer[result16++]=Data;					// Tokennummer ausgeben
						}
						else if (i=='*') 								// Token vollstndig ausgeben
							string_out(buffer,(PGM_P)pgm_read_word(&tokens[Data]));
					}
				}
				
				if (pgm_read_byte(pointer) =='T')	{	// Token ausgeben
					i = pgm_read_byte(++pointer);		// Folgezeichen nach i laden
					if (i=='*') i=Index;				// '*' = Variable nutzen
					else i -= i>'9' ? 'A'-10 : '0';	// sonst Zeichen als Index betrachten
					string_out(buffer,(PGM_P)pgm_read_word(&tokens[i]));	// Token ausgeben
				}
				
				pointer++; // Das auf %VA folgende Zeichen berlesen
			}
			
			// Bearbeitung verschiedener Steuermarken
			
			if (strncmp_P("ANFT",(pointer+1),4)== 0){	// Start eines Wiederholblockes
				pointer += 5;								// Hinter der Marke geht es weiter
				Zeiger = pointer;							// Anfang des Wiederholblockes merken
				Index = 0;									// Startwert fr den Index setzen
				do pointer++; while (strncmp_P("ENDT",(pointer+1),4)!=0); // Blockende suchen
			}
			
			if (strncmp_P("ENDT",(pointer+1),4)== 0){	// Ende des Wiederholblockes
				Index += 1;									// nchster Baustein
				if (Index<MAX_DEVICES)						// Beim letzten Durchlauf beenden,
				if ((VA3>0)&(VA3<4)) {					// evtl. Ausgabebereich einschrnken
					if (DALLAS[Index][0]==0x7f) 			// wenn die Position leer ist,
						do Index++;						//  gehen wir zum nchsten Baustein,
						while ((Index<MAX_DEVICES)			//  solange nicht der letzte Baustein erreicht wurde
							 & (DALLAS[Index][0]==0x7f));	//  und auch diese Position leer ist
					else {
						if (VA3>1) {						// nur Thermometer anzeigen
						 if (DALLAS[Index][1]==0xff)		// wenn es kein Thermometer ist,
							do Index++;					//  gehen wir zum nchsten Baustein,
							while ((Index<MAX_DEVICES)		//  solange nicht der letzte Baustein erreicht wurde
							 & (DALLAS[Index][1]==0xff));	//  und kein Thermometer gefunden wurde
						}
						if ((VA3==3)&(Index<MAX_DEVICES))	// nur aktive Thermometer anzeigen
						 if ((DALLAS[Index][1]==0xff)		// wenn es kein Thermometer ist,
							|(DALLAS[Index][1]==0x7f))	//  oder wenn es nicht aktiv ist
							do Index++;					//  gehen wir zum nchsten Baustein,
							while ((Index<MAX_DEVICES)		//  solange nicht der letzte Baustein erreicht wurde
							 & ((DALLAS[Index][1]==0xff)	//  und kein Thermometer gefunden wurde
							 | (DALLAS[Index][1]==0x7f)));	//  und kein aktives Thermometer gefunden wurde
					}
				}
				if (Index>=MAX_DEVICES)	pointer += 5;	// Nach dem letzten Durchlauf beenden wir,
				else 	pointer = Zeiger;					// sonst wiederholen wir den Block
			}
			
			if (strncmp_P("ANFN",(pointer+1),4)== 0){	// Start eines Wiederholblockes
				pointer += 5;								// Hinter der Marke geht es weiter
				Zeiger = pointer;							// Anfang des Wiederholblockes merken
				Index = -1;								// Startwert fr den Index setzen
				do pointer++; while (strncmp_P("ENDN",(pointer+1),4)!=0); // Blockende suchen
			}
			
			if (strncmp_P("ENDN",(pointer+1),4)== 0){	// Ende des Wiederholblockes
				Index++;									// nchster Baustein
				if (Index>=MAX_TOKENS)	pointer += 5;		// Nach dem letzten Durchlauf beenden wir,
				else 	pointer = Zeiger;					// sonst wiederholen wir den Block
			}
			
			if (strncmp_P("ANFY",(pointer+1),4)== 0){	// Start eines Wiederholblockes
				pointer += 5;								// Hinter der Marke geht es weiter
				Zeiger = pointer;							// Anfang des Wiederholblockes merken
				Index = -1;								// Startwert fr den Index setzen
				do pointer++; while (strncmp_P("ENDY",(pointer+1),4)!=0); // Blockende suchen
			}
			
			if (strncmp_P("ENDY",(pointer+1),4)== 0){	// Ende des Wiederholblockes
				if (Index < 0) 							// Beim 1. Durchlauf Adresszeile ausgeben
					Adresszeile (buffer,result16);			// Adresszeile fr Speicherdump ausgeben
				else
					Datenzeile (buffer,result16,(int)Index*16,*readEEPROM);	// Datenzeile ausgeben
				result16 += 79;								// Pointer korrekt setzen
				Index++;									// nchste Zeile
				if (Index>63)	pointer += 5;				// Nach dem letzten Durchlauf beenden wir,
				else 	pointer = Zeiger;					// sonst wiederholen wir den Block
			}
			
			if (strncmp_P("END.",(pointer+1),4)== 0){	// Die Webseite ist fertig, wenn %END. erreicht wurde
				for(int a=0; a<1000; a++) {nop();};		// Wait a short Time (warum auch immer)
				break;										// Abbruch der Schleife
			}
		} // Ende der Auswertung der <TAG>s
			
		Data = pgm_read_byte_near(pointer++);	// Datenbyte lesen
		buffer[result16++] = Data;				// Datenbyte in den Buffer
			
		if (result16 >  (MTU_SIZE - 1)) {		//sind die Daten lnger als ein Ethernetbuffer,
			Buffer_Full = 1;					// dann ist der Buffer voll
			pointerold = pointer;				// Speichern des Pointers auf die Quelldaten
			break;								// und Abbruch der Schleife
		}
	}
	TCP_New_Packtlen (buffer,bufferlen,result16);
	return(Buffer_Full);
}

//############################################################################
//
char tcp_add_datastring (char *pointer,char *buffer,int *bufferlen)
//############################################################################
{
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned char Data = 1;
	unsigned char Buffer_Full = 0;

	//Errechnet den Startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 	((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
	for(;;) {
		Data = *pointer++;
		buffer[result16] = Data;
		result16++;
			
		if (result16 >  (MTU_SIZE - 1)) { //sind die Daten lnger als ein Ethernetbuffer dann Abbruch
			Buffer_Full = 1;
			break;
		}
			
		if (*pointer == 0) {	//Abbruch wenn 0 erreicht wurde
			for(int a=0 ;a<1000 ;a++) {nop();};	//Wait a short Time
			break;
		}
	}
	TCP_New_Packtlen (buffer,bufferlen,result16);
	return(Buffer_Full);
}

//############################################################################
//
void TCP_New_Packtlen (char *buffer,int *bufferlen,unsigned int result16)	
//############################################################################
{	
	result16 = result16 + 4;	// bufferheader zur neuen ethernetpaketlnge addieren 
	*bufferlen = result16;	
	result16 = result16 - 18;	// ip bufferlnge aus Ethernet Lnge (Ethernetframe - bufferheader) errechnen
	buffer[IP_PKTLEN]   = ((result16 & 0xFF00) >> 8);	// IPlnge (ip_pktlenH) in den buffer schreiben 
	buffer[IP_PKTLEN+1] = (result16 & 0x00FF);		// (ip_pktlenL)
	return;
}

//############################################################################
//
void tcp_make (char *buffer)
//############################################################################
{
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned long result32 = 0x00000000;
	unsigned char DataH;
	unsigned char DataL;

	//Schreibt neuen seq und Ack Counter	
    buffer[TCP_ACKNUM] = (Seq_counter & 0xFF000000) >> 24;
    buffer[TCP_ACKNUM+1] = (Seq_counter & 0x00FF0000) >> 16;
    buffer[TCP_ACKNUM+2] = (Seq_counter & 0x0000FF00) >> 8;
    buffer[TCP_ACKNUM+3] = Seq_counter & 0x000000FF;

    buffer[TCP_SEQNUM] = (Ack_counter & 0xFF000000) >> 24;
    buffer[TCP_SEQNUM+1] = (Ack_counter & 0x00FF0000) >> 16;
    buffer[TCP_SEQNUM+2] = (Ack_counter & 0x0000FF00) >> 8;
    buffer[TCP_SEQNUM+3] = Ack_counter & 0x000000FF;

    //Tauscht den TCP source Port mit TCP destination port yyyy >> XXXX

	DataH = buffer[TCP_SRCPORT];
    buffer[TCP_SRCPORT] = buffer[TCP_DESTPORT];
    buffer[TCP_DESTPORT] = DataH;

	DataL = buffer[TCP_SRCPORT+1];
    buffer[TCP_SRCPORT+1] = buffer[TCP_DESTPORT+1];
    buffer[TCP_DESTPORT+1] = DataL;

    Make_IP_Header(buffer);		// IP Header erzeugen	

	//Berechnung der TCP Checksumme
	//Alle Daten im TCP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	buffer[TCP_CHKSUM] = 0x00;
	buffer[TCP_CHKSUM+1] = 0x00;

	//Berechnet Headerlnge und Addiert Pseudoheaderlnge 2XIP = 8
	result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1] + 8;
	result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2);
	result32 = result16 - 2;

	//Pointer wird auf das erste buffer im IP Header gesetzt
	//Routine berechnet die Checksumme
	result16 = checksum (&buffer[IP_SRCADDR], result16, result32);

	//schreibt checksum ins buffer (INT H Byte)
	buffer[TCP_CHKSUM] = ((result16 & 0xFF00) >> 8);

	//schreibt checksum ins buffer (INT L Byte)
	buffer[TCP_CHKSUM+1] = (result16 & 0x00FF);

	//Habe Fertig!!
}

//############################################################################
//
void TCP_PORT_CLOSE (char *buffer,int *bufferlen)
//############################################################################
{
	tcp_store(buffer);		//Speichert Sequenzcounter und Aknowledgecounter
	buffer[TCP_HDRFLAGS+1] = ACK_FLAG | FIN_FLAG | PSH_FLAG;	//Setzen des FIN Flag
	tcp_make(buffer);		//Erzeugt ein TCP buffer 
	Write_Ethernet_Frame (buffer,*bufferlen);	//Sendet das erzeugte TCP buffer 
}

//############################################################################
//
int TCP_OPEN (char *buffer,int *bufferlen)
//############################################################################
{
 unsigned int tcp_srcport;

 tcp_srcport=(buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];

 unsigned char tcp_hdrflags1=buffer[TCP_HDRFLAGS+1];
 
	if ((tcp_hdrflags1 & SYN_FLAG) > 0 
	     && (tcp_hdrflags1 & (PSH_FLAG | ACK_FLAG)) == 0)
	{
		//Speichern des Socket
		for (unsigned char a=0;a<Max_TCP_Sockets;a++)
			{
			tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
			if (tcp_socket->Store == 0)
				{
				tcp_socket->Store = tcp_srcport;
				tcp_socket->Status = TCP_SOCKET_NOT_USE;
				break;
				}
			}
		tcp_store(buffer);							//Speichert Sequenzcounter und Aknowledgecounter
		buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;		//Setzen des Ack Flag
		tcp_make(buffer);							//Erzeugt ein TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);	//Sendet das erzeugte TCP buffer 
		return(1);
	}
		
	if ((tcp_hdrflags1 & RST_FLAG) > 0) 
	{
		for (unsigned char a=0;a<Max_TCP_Sockets;a++)
			{
			tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
			if (tcp_socket->Store == tcp_srcport)
				{
				tcp_socket->Store = 0;
				break;
				}
			}
		return(1);
	}
		
	if ((tcp_hdrflags1 & FIN_FLAG) > 0) 
	{
		for (unsigned char a=0;a<Max_TCP_Sockets;a++)
			{
			tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

			if (tcp_socket->Store == tcp_srcport)
				{
				tcp_socket->Store = 0;
				break;
				}
			}
		buffer[TCP_HDRFLAGS+1] = RST_FLAG;			//Setzen des Ack Flag
		tcp_store(buffer);							//Speichert Sequenzcounter und Aknowledgecounter
		Seq_counter = Seq_counter + 1;				//Seq_counter um 1 erhhen
		tcp_make(buffer);							//Erzeugt ein TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);	//Sendet das erzeugte TCP buffer 
		return(1);
	}
return(0);
}

//############################################################################
//Verwaltet TCP Stack 
char TCP_Stack (char *buffer,int *bufferlen,unsigned char *Stackpointer)
//############################################################################
{
	//ist fr Verbindungsaufbau zustndig TCP SYNC
	if (TCP_OPEN(buffer,bufferlen)==1)
		{
		return(1);//keine Daten fr Anwendung
		}
	
	unsigned int	TCP_Socket = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];

	for (unsigned char a=0;a<Max_TCP_Sockets;a++)
		{
		tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

		if(TCP_Socket == tcp_socket->Store)
			{
			if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 
				&& (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
				{
				*Stackpointer = a;
				return(0); //Daten fr Anwendung
				}
			
			if (tcp_socket->Status == TCP_SOCKET_CLOSE)
				{
				tcp_socket->Store = TCP_SOCKET_NOT_USE;
				tcp_socket->Status = 0; //TCP Socket wird im TCP STACK geschlossen
				printf("TCP Socket Close Socket:%d Stack:%d\n",TCP_Socket,a);
				TCP_PORT_CLOSE (buffer,bufferlen);
				*Stackpointer = a;
				return(1); //Keine Daten fr Anwendung
				}
			
			if (tcp_socket->Status == TCP_SOCKET_NOT_USE)
				{
				printf("TCP Socket Open Socket:%d Stack:%d\n",TCP_Socket,a);
				tcp_socket->Status = TCP_SOCKET_OPEN1; //TCP Socket wird im TCP Stack geffnet
				*Stackpointer = a;
				return(0); //ACK fr Anwendung
				}
			
			if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 
				&& (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
				{
				*Stackpointer = a;
				return(0); //ACK fr Anwendung
				}
			}
		}
	return (1);
}
